/**
Action Script library. ContextMenu class implementation
Copyright (C) 2005 

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_context_menu.hh"

typedef void (ASContextMenu::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASContextMenu::init,			// 0
	&ASContextMenu::copy,			// 1
	&ASContextMenu::hideBuiltInItems,// 2
	// Need to be at the end.
	&ASContextMenu::addProperty,		
	&ASContextMenu::registerClass,	
	&ASContextMenu::AStoString,		
	&ASContextMenu::unwatch,			
	&ASContextMenu::valueOf,			
	&ASContextMenu::watch			
};

/**
 * The constructor
 **/
ASContextMenu::ASContextMenu(Script *s, Graphics *g) : ASObject(s,g,L"ContextMenu") {
}

/**
 * The destructor
 **/
ASContextMenu::~ASContextMenu() {
}

/**
 * Return a function descriptor
 */
Function *ASContextMenu::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"ContextMenu") 		{func->setFunctionIndex(0); func->setNumParams(1); }
	if (memberName == L"copy") 				{func->setFunctionIndex(1); func->setNumParams(0); }
	if (memberName == L"hideBuiltInItems") 	{func->setFunctionIndex(2); func->setNumParams(0); }
	finishFunctionSetup(memberName,3,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASContextMenu::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}
/**
 *
 **/
void ASContextMenu::init() {
	puts("TODO");
}

/**
 * Returns a copy of the specified ContextMenu object.
 **/
void ASContextMenu::copy() {
	puts("TODO");
	noReturnValue();
}

/**
 *  Hides most built-in items in the Flash Player context menu.
 **/
void ASContextMenu::hideBuiltInItems() {
	puts("TODO");
	noReturnValue();
}

