/**
Action Script library. ContextMenuItems class implementation
Copyright (C) 2005

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_context_menuitem.hh"

typedef void (ASContextMenuItem::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASContextMenuItem::init,	// 0
	&ASContextMenuItem::copy,	// 1
	// Need to be at the end.
	&ASContextMenuItem::addProperty,		
	&ASContextMenuItem::registerClass,	
	&ASContextMenuItem::AStoString,		
	&ASContextMenuItem::unwatch,			
	&ASContextMenuItem::valueOf,			
	&ASContextMenuItem::watch			
};

/**
 * The constructor
 **/
ASContextMenuItem::ASContextMenuItem(Script *s, Graphics *g) : ASObject(s,g,L"ContextMenuItem") {
}

/**
 * The destructor
 **/
ASContextMenuItem::~ASContextMenuItem() {
}

/**
 * Return a function descriptor
 */
Function *ASContextMenuItem::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"ContextMenuItem")	{func->setFunctionIndex(0); func->setNumParams(5); }
	if (memberName == L"copy") 				{func->setFunctionIndex(1); func->setNumParams(0); }
	finishFunctionSetup(memberName,2,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASContextMenuItem::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}
/**
 *
 **/
void ASContextMenuItem::init() {
	puts("TODO");
}

/**
 * creates and returns a copy of the specified ContextMenuItem object. 
 * The copy includes all properties of the original object.
 **/
void ASContextMenuItem::copy() {
	puts("TODO");
	noReturnValue();
}
