/**
Action Script library.	CustomAction class implementation
Copyright (C) 2005  

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_custom_actions.hh"

typedef void (ASCustomActions::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASCustomActions::init,			// 0
	&ASCustomActions::get,			// 1
	&ASCustomActions::install,		// 2
	&ASCustomActions::list,			// 3
	&ASCustomActions::uninstall,	// 4
	// Need to be at the end.
	&ASCustomActions::addProperty,		
	&ASCustomActions::registerClass,	
	&ASCustomActions::AStoString,		
	&ASCustomActions::unwatch,			
	&ASCustomActions::valueOf,			
	&ASCustomActions::watch			
};

/**
 * The constructor
 **/
ASCustomActions::ASCustomActions(Script *s, Graphics *g) : ASObject(s,g,L"CustomActions") {
}

/**
 * The destructor
 **/
ASCustomActions::~ASCustomActions() {
}

/**
 * Return a function descriptor
 */
Function *ASCustomActions::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"CustomActions") {func->setFunctionIndex(0); func->setNumParams(1); }
	if (memberName == L"get") 			{func->setFunctionIndex(1); func->setNumParams(0); }
	if (memberName == L"install") 		{func->setFunctionIndex(2); func->setNumParams(2); }
	if (memberName == L"list") 			{func->setFunctionIndex(3); func->setNumParams(0); }
	if (memberName == L"uninstall") 	{func->setFunctionIndex(4); func->setNumParams(1); }
	finishFunctionSetup(memberName,5,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASCustomActions::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASCustomActions::init() {
	puts("TODO");
}

/**
 * Reads the contents of a custom action XML definition file.
 **/
void ASCustomActions::get() {
	puts("TODO");
	noReturnValue();
}

/**
 * Installs a new custom action XML definition file.
 **/
void ASCustomActions::install() {
	puts("TODO");
	noReturnValue();
}

/**
 * Returns a list of all registered custom actions.
 **/
void ASCustomActions::list() {
	puts("TODO");
	noReturnValue();
}

/**
 * Removes a custom action XML definition file.
 **/
void ASCustomActions::uninstall() {
	puts("TODO");
	noReturnValue();
}
