/**
Action Script library. Date library definition
Copyright (C) 2005  Christophe Choquet (cchoquet@users.sourceforge.net)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _AS_DATE_HH
#define _AS_DATE_HH
#include "as_object.hh"

class ASDate : public ASObject{
public:
	ASDate(Script *s, Graphics *g);
	~ASDate();
	Function *getFunctionMember(wstring memberName);
	void 	callFunction(Function *f);
	void 	init();
	ASInterface*getNewInstance(Script *s,Graphics *g) { return new ASDate(s,g); }

	void	getDate();
	void	getDay();
	void	getFullYear();
	void	getHours();
	void	getMilliseconds();
	void	getMinutes();
	void	getMonth();
	void	getSeconds();
	void	getTime();
	void	getTimezoneOffset();
	void	getUTCDate();
	void	getUTCDay();
	void	getUTCFullYear();
	void	getUTCHours();
	void	getUTCMilliseconds();
	void	getUTCMinutes();
	void	getUTCMonth();
	void	getUTCSeconds();
	void	getYear();
	void	setDate();
	void	setFullYear();
	void	setHours();
	void	setMilliseconds();
	void	setMinutes();
	void	setMonth();
	void	setSeconds();
	void	setTime();
	void	setUTCDate();
	void	setUTCFullYear();
	void	setUTCHours();
	void	setUTCMilliseconds();
	void	setUTCMinutes();
	void	setUTCMonth();
	void	setUTCSeconds();
	void	setYear();
	void	AStoString();
	void	UTC();
private:
	// On linux we can't set the date, as root priviledge is required.
	// We emulate the date setting during a flash session.
	long	timeShift;			
	long 	year,month,date,hour,minute,second,millisecond;
	int		dayWeek;

	void	setLocalSystemDate();
	void	setUTCSystemDate();
	void	getUTCSystemDate();
	void	getLocalSystemDate();
	long	getLocalTimeInMillis();
	long	getUTCTimeInMillis();
};
#endif
