/**
Action Script library. LocalConnection class implementation
Copyright (C) 2005

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_local_connection.hh"

typedef void (ASLocalConnection::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASLocalConnection::init,		// 0
	&ASLocalConnection::close,		// 1
	&ASLocalConnection::connect,	// 2
	&ASLocalConnection::domain,		// 3
	&ASLocalConnection::send,		// 4
	// Need to be at the end.
	&ASLocalConnection::addProperty,		
	&ASLocalConnection::registerClass,	
	&ASLocalConnection::AStoString,		
	&ASLocalConnection::unwatch,			
	&ASLocalConnection::valueOf,			
	&ASLocalConnection::watch			
};

/**
 * The constructor
 **/
ASLocalConnection::ASLocalConnection(Script *s, Graphics *g) : ASObject(s,g,L"LocalConnection") {
}

/**
 * The destructor
 **/
ASLocalConnection::~ASLocalConnection() {
}

/**
 * Return a function descriptor
 */
Function *ASLocalConnection::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"LocalConnection"){func->setFunctionIndex(0); func->setNumParams(0); }
	if (memberName == L"close") 		{func->setFunctionIndex(1); func->setNumParams(0); }
	if (memberName == L"connect") 		{func->setFunctionIndex(2); func->setNumParams(1); }
	if (memberName == L"domain") 		{func->setFunctionIndex(3); func->setNumParams(0); }
	if (memberName == L"send") 			{func->setFunctionIndex(4); func->setNumParams(10); } // infinity
	finishFunctionSetup(memberName,5,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASLocalConnection::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASLocalConnection::init() {
	puts("TODO");
}

/**
 * Closes (disconnects) the LocalConnection object.
 **/
void ASLocalConnection::close() {
	puts("TODO");
	noReturnValue();
}

/**
 * Prepares the LocalConnection object to receive commands from a LocalConnection.send() command.
 **/
void ASLocalConnection::connect() {
	puts("TODO");
	noReturnValue();
}

/**
 * Returns a string representing the superdomain of the location of the current SWF file.
 **/
void ASLocalConnection::domain() {
	puts("TODO");
	noReturnValue();
}

/**
 * Invokes a method on a specified LocalConnection object.
 **/
void ASLocalConnection::send() {
	puts("TODO");
	noReturnValue();
}
