/**
Action Script library. System class implementation
Copyright (C) 2005

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_system.hh"

typedef void (ASSystem::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASSystem::init,			// 0
	&ASSystem::setClipboard,	// 1
	&ASSystem::showSettings,	// 2
	// Need to be at the end.
	&ASSystem::addProperty,		
	&ASSystem::registerClass,	
	&ASSystem::AStoString,		
	&ASSystem::unwatch,			
	&ASSystem::valueOf,			
	&ASSystem::watch
};

/**
 * The constructor
 **/
ASSystem::ASSystem(Script *s, Graphics *g) : ASObject(s,g,L"System") {
}

/**
 * The destructor
 **/
ASSystem::~ASSystem(){
}

/**
 * Return a function descriptor
 */
Function *ASSystem::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"System") 		{func->setFunctionIndex(0); func->setNumParams(0); }
	if (memberName == L"setClipboard") 	{func->setFunctionIndex(1); func->setNumParams(1); }
	if (memberName == L"showSettings") 	{func->setFunctionIndex(2); func->setNumParams(1); }
	finishFunctionSetup(memberName,3,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASSystem::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASSystem::init() {
	puts("TODO");
}

/**
 * Replaces the contents of the system clipboard with a text string.
 **/
void ASSystem::setClipboard() {
	puts("TODO");
	noReturnValue();
}

/**
 * Displays a Flash Player Settings panel.
 **/
void ASSystem::showSettings() {
	puts("TODO");
	noReturnValue();
}


