/**
Action Script library. SystemCapabilities class implementation
Copyright (C) 2005  

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_system_capabilities.hh"

typedef void (ASSystemCapabilities::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASSystemCapabilities::init,		// 0
	// Need to be at the end.
	&ASSystemCapabilities::addProperty,		
	&ASSystemCapabilities::registerClass,	
	&ASSystemCapabilities::AStoString,		
	&ASSystemCapabilities::unwatch,			
	&ASSystemCapabilities::valueOf,			
	&ASSystemCapabilities::watch
};

/**
 * The constructor
 **/
ASSystemCapabilities::ASSystemCapabilities(Script *s, Graphics *g) : ASObject(s,g,L"System.capabilities") {
}

/**
 * The destructor
 **/
ASSystemCapabilities::~ASSystemCapabilities() {
}

/**
 * Return a function descriptor
 */
Function *ASSystemCapabilities::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"System.capabilities"){func->setFunctionIndex(0); func->setNumParams(0); }
	finishFunctionSetup(memberName,1,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASSystemCapabilities::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASSystemCapabilities::init() {
	puts("TODO");
}
