/**
Action Script library. TextField definition
Copyright (C) 2005 Christophe Choquet (cchoquet@users.sourceforge.net)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _AS_TEXT_FIELD_HH
#define _AS_TEXT_FIELD_HH
#include "as_text_format.hh"
#include "as_object.hh"

#undef funcPtr
class ASTextField;
typedef void (ASTextField::*funcPtrASTextField)();

class ASTextField : public ASObject{
public:
	ASTextField(ASTextField*);
	ASTextField(Script *s, Graphics *g);
	~ASTextField();
	Function *getFunctionMember(wstring memberName);
	void 	callFunction(Function *func);
	void 	setMainMember(ValueObject  *v);
	ValueObject*getMainMember();
	ValueObject*getMember(wstring memberName);
	void 	init();
	ASInterface*getNewInstance(Script *s,Graphics *g) { return new ASTextField(s,g); }
	bool	isStatic() { return textFieldStatic; }
	ASInterface* getObjectDeepCopy(bool p);

	void	addListener();
	void	getFontList();
	void	getDepth();
	void	getNewTextFormat();
	void	getTextFormat();
	void	removeListener();
	void	removeTextField();
	void	replaceSel();
	void	setNewTextFormat();
	void	setTextFormat();
	void	replaceText();

	// CallBacks
	void	onPress();
	void	onReleaseOutside();

	void	setStaticTextField(DefineTextTag *);
	void	setDynamicText(DefineEditTextTag *);
	void	toGraphic();
	ASTextFormat *getDirectTextFormat() { return textFormat; }
	wstring	toString() const;
	void	computeBounds();

private:
	bool	textFieldStatic;
	DefineTextTag *staticTag;
	long	__zz; // 64 bit pointer corruption
	ASTextFormat *textFormat;
	void 	*eventData;

	bool 	callInternalEvent(string eventName, void *data);
	funcPtrASTextField	eventDispatcher(string eventName);
};
#endif
