/**
Plugin interface. Konqueror.
Copyright (C) 2005  Christophe Choquet (cchoquet@users.sourceforge.net)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/

#ifndef _KFLASH_PLUGIN_HH
#define _KFLASH_PLUGIN_HH
#include <kparts/browserextension.h>
#include <kparts/factory.h>
#include <kparts/part.h>
#include <kparts/plugin.h>


class KAboutData;
class KInstance;
class KflashPartBrowserExtension;
class Viewer;

class KflashPartFactory : public KParts::Factory {
	Q_OBJECT
public:
	KflashPartFactory();
	virtual ~KflashPartFactory();

	virtual KParts::Part *createPartObject(QWidget *parentwidget = NULL, const char *widgetname = NULL, QObject *parent = NULL, const char *name = NULL, const char* classname = "KParts::Part", const QStringList &args = QStringList());
	static KInstance *instance();

private:
	static KInstance *s_instance;
	static KAboutData *s_about;
};


class KflashPlugin : public KParts::ReadOnlyPart {
	Q_OBJECT
public:
 	KflashPlugin( QObject* parent = 0, const char* name = 0 );
 	virtual ~KflashPlugin();

protected:
	virtual bool openFile();
private:
	KflashPartBrowserExtension *m_extension;
	//Viewer *viewer;
};


class KflashPartBrowserExtension : public KParts::BrowserExtension {
	Q_OBJECT
	friend class KflashPlugin;
public:	
	KflashPartBrowserExtension(KflashPlugin *parent);
	virtual ~KflashPartBrowserExtension();
};

#endif
